﻿Imports System.IO

Module Module1
    Sub Main()
        Dim fileName As String = "C:\PCA\50\!CB170\CBCONFIG.EXE_FileDossier\CBCONFIG_EXE-res-REG.dlg"
        Dim data As Byte() = File.ReadAllBytes(fileName)

        Call ParseDialog(fileName)
    End Sub

    Private Sub ParseDialog(filePath As String)
        Dim op As String = ""
        Dim isSetfont As Boolean = False
        ''Try
        Using fs As New FileStream(filePath, FileMode.Open, FileAccess.Read)
            Using br As New BinaryReader(fs)

                ' Move the stream position to the offset where the window styles are located
                ' For example, let's assume they start at byte offset 0x10 (16 bytes)
                fs.Seek(0, SeekOrigin.Begin)

                ' Read the 4-byte window styles
                Dim stylesBytes As Byte() = br.ReadBytes(4)

                ' Convert bytes to a single 32-bit unsigned integer
                Dim windowStyles As UInteger = BitConverter.ToUInt32(stylesBytes, 0)

                ' Output the styles
                op = op + "Window Style: 0x" & windowStyles.ToString("X8") + vbNewLine

                ' Check for various window styles
                If (windowStyles And &H1) <> 0 Then
                    op = op + "WS_OVERLAPPED" + vbNewLine
                End If
                If (windowStyles And &H2) <> 0 Then
                    op = op + "WS_POPUP" + vbNewLine
                End If
                If (windowStyles And &H40000000) <> 0 Then
                    op = op + "WS_CHILD" + vbNewLine
                End If
                If (windowStyles And &H20000000) <> 0 Then
                    op = op + "WS_MINIMIZE" + vbNewLine
                End If
                If (windowStyles And &H10000000) <> 0 Then
                    op = op + "WS_VISIBLE" + vbNewLine
                End If
                If (windowStyles And &H8000000) <> 0 Then
                    op = op + "WS_DISABLED" + vbNewLine
                End If
                If (windowStyles And &H4000000) <> 0 Then
                    op = op + "WS_CLIPSIBLINGS" + vbNewLine
                End If
                If (windowStyles And &H2000000) <> 0 Then
                    op = op + "WS_CLIPCHILDREN" + vbNewLine
                End If
                If (windowStyles And &H1000000) <> 0 Then
                    op = op + "WS_MAXIMIZE" + vbNewLine
                End If
                If (windowStyles And &H40000) <> 0 Then
                    op = op + "WS_THICKFRAME" + vbNewLine
                End If
                If (windowStyles And &H200000) <> 0 Then
                    op = op + "WS_VSCROLL" + vbNewLine
                End If
                If (windowStyles And &H100000) <> 0 Then
                    op = op + "WS_HSCROLL" + vbNewLine
                End If
                If (windowStyles And &H80000) <> 0 Then
                    op = op + "WS_SYSMENU" + vbNewLine
                End If
                If (windowStyles And &HC00000) <> 0 Then
                    op = op + "WS_CAPTION" + vbNewLine
                End If
                If (windowStyles And &H800000) <> 0 Then
                    op = op + "WS_BORDER" + vbNewLine
                End If
                If (windowStyles And &H400000) <> 0 Then
                    op = op + "WS_DLGFRAME" + vbNewLine
                End If
                If (windowStyles And &H10000) <> 0 Then
                    op = op + "WS_ACTIVECAPTION" + vbNewLine
                End If
                If (windowStyles And &H8) <> 0 Then
                    op = op + "WS_ALWAYSONTOP" + vbNewLine
                End If
                If (windowStyles And &H8) <> 0 Then
                    op = op + "WS_EX_TOPMOST" + vbNewLine
                End If
                If (windowStyles And &H20000) <> 0 Then
                    op = op + "WS_GROUP" + vbNewLine
                End If
                If (windowStyles And &H40) <> 0 Then
                    op = op + "DS_SETFONT" + vbNewLine
                    isSetfont = True
                End If
                If (windowStyles And &H4) <> 0 Then
                    op = op + "DS_3DLOOK" + vbNewLine
                End If
                If (windowStyles And &H1) <> 0 Then
                    op = op + "DS_ABSALIGN" + vbNewLine
                End If
                If (windowStyles And &H800) <> 0 Then
                    op = op + "DS_CENTER" + vbNewLine
                End If
                If (windowStyles And &H1000) <> 0 Then
                    op = op + "DS_CENTERMOUSE" + vbNewLine
                End If
                If (windowStyles And &H2000) <> 0 Then
                    op = op + "DS_CONTEXTHELP" + vbNewLine
                End If
                If (windowStyles And &H400) <> 0 Then
                    op = op + "DS_CONTROL" + vbNewLine
                End If
                If (windowStyles And &H8) <> 0 Then
                    op = op + "DS_FIXEDSYS" + vbNewLine
                End If
                If (windowStyles And &H80) <> 0 Then
                    op = op + "DS_MODALFRAME" + vbNewLine
                End If
                If (windowStyles And &H20) <> 0 Then
                    op = op + "DS_LOCALEDIT" + vbNewLine
                End If
                If (windowStyles And &H10) <> 0 Then
                    op = op + "DS_NOFAILCREATE" + vbNewLine
                End If
                If (windowStyles And &H100) <> 0 Then
                    op = op + "DS_NOIDLEMSG" + vbNewLine
                End If
                If (windowStyles And &H200) <> 0 Then
                    op = op + "DS_SETFOREGROUND" + vbNewLine
                End If
                If (windowStyles And &H1000) <> 0 Then
                    op = op + "DS_SHELLFONT" + vbNewLine
                End If
                If (windowStyles And &H2) <> 0 Then
                    op = op + "DS_SYSMODAL" + vbNewLine
                End If

                Dim numberControls As Byte = br.ReadByte
                op = op + vbNewLine + "Number of Controls : " + numberControls.ToString + vbNewLine
                Dim dXCoordinate As Short = br.ReadUInt16
                op = op + "X-Coordinate       : " + dXCoordinate.ToString + vbNewLine
                Dim dYCoordinate As Short = br.ReadUInt16
                op = op + "Y-Coordinate       : " + dYCoordinate.ToString + vbNewLine
                Dim dWidth As Short = br.ReadUInt16
                op = op + "Width              : " + dWidth.ToString + vbNewLine
                Dim dHeight As Short = br.ReadUInt16
                op = op + "Height             : " + dHeight.ToString + vbNewLine
                Dim isMenu As Byte = br.ReadByte
                op = op + "Menu               : " + isMenu.ToString + vbNewLine
                Dim dlgClass As Byte = br.ReadByte
                Dim rdByte As Byte
                If dlgClass = 0 Then
                    op = op + "Dialog Class       : " + dlgClass.ToString + vbNewLine
                Else
                    Dim dlgClass2 As String = Chr(dlgClass)
                    Do
                        rdByte = br.ReadByte
                        If rdByte = 0 Then
                            Exit Do
                        End If
                        dlgClass2 = dlgClass2 + Chr(rdByte)
                    Loop
                    op = op + "Dialog Class       : " + dlgClass2 + vbNewLine
                End If
                Dim dlgTitle As String = ""
                Do
                    rdByte = br.ReadByte
                    If rdByte = 0 Then
                        Exit Do
                    End If
                    dlgTitle = dlgTitle + Chr(rdByte)
                Loop
                op = op + "Dialog Title       : " + dlgTitle + vbNewLine
                If isSetfont = True Then
                    Dim fSize As Short = br.ReadUInt16
                    op = op + "Font Size          : " + fSize.ToString + vbNewLine
                    Dim fntName As String = ""
                    rdByte = 0
                    Do
                        rdByte = br.ReadByte
                        If rdByte = 0 Then
                            Exit Do
                        End If
                        fntName = fntName + Chr(rdByte)
                    Loop
                    op = op + "Font Name          : " + fntName + vbNewLine
                End If
                For i = 1 To numberControls
                    op = op + vbNewLine
                    op = op + "Control            : " + i.ToString + vbNewLine
                    Dim cXCoordinate As Short = br.ReadInt16
                    op = op + "  X-Coordinate     : " + cXCoordinate.ToString + vbNewLine
                    Dim cYCoordinate As Short = br.ReadInt16
                    op = op + "  Y-Coordinate     : " + cYCoordinate.ToString + vbNewLine
                    Dim cXWidth As Short = br.ReadUInt16
                    op = op + "  Width            : " + cXWidth.ToString + vbNewLine
                    Dim cYHeight As Short = br.ReadUInt16
                    op = op + "  Height           : " + cYHeight.ToString + vbNewLine
                    Dim cID As Integer = br.ReadInt16
                    op = op + "  ID               : " + cID.ToString + vbNewLine
                    stylesBytes = br.ReadBytes(4)
                    Dim windowStyles2 As UInteger = BitConverter.ToUInt32(stylesBytes, 0)
                    op = op + "Window Style       : 0x" & windowStyles2.ToString("X8") + vbNewLine
                    If (windowStyles2 And &H1) <> 0 Then
                        op = op + "  WS_OVERLAPPED" + vbNewLine
                    End If
                    If (windowStyles2 And &H2) <> 0 Then
                        op = op + "  WS_POPUP" + vbNewLine
                    End If
                    If (windowStyles2 And &H40000000) <> 0 Then
                        op = op + "  WS_CHILD" + vbNewLine
                    End If
                    If (windowStyles2 And &H20000000) <> 0 Then
                        op = op + "  WS_MINIMIZE" + vbNewLine
                    End If
                    If (windowStyles2 And &H10000000) <> 0 Then
                        op = op + "  WS_VISIBLE" + vbNewLine
                    End If
                    If (windowStyles2 And &H8000000) <> 0 Then
                        op = op + "  WS_DISABLED" + vbNewLine
                    End If
                    If (windowStyles2 And &H4000000) <> 0 Then
                        op = op + "  WS_CLIPSIBLINGS" + vbNewLine
                    End If
                    If (windowStyles2 And &H2000000) <> 0 Then
                        op = op + "  WS_CLIPCHILDREN" + vbNewLine
                    End If
                    If (windowStyles2 And &H1000000) <> 0 Then
                        op = op + "  WS_MAXIMIZE" + vbNewLine
                    End If
                    If (windowStyles2 And &H40000) <> 0 Then
                        op = op + "  WS_THICKFRAME" + vbNewLine
                    End If
                    If (windowStyles2 And &H200000) <> 0 Then
                        op = op + "  WS_VSCROLL" + vbNewLine
                    End If
                    If (windowStyles2 And &H100000) <> 0 Then
                        op = op + "  WS_HSCROLL" + vbNewLine
                    End If
                    If (windowStyles2 And &H80000) <> 0 Then
                        op = op + "  WS_SYSMENU" + vbNewLine
                    End If
                    If (windowStyles2 And &HC00000) <> 0 Then
                        op = op + "  WS_CAPTION" + vbNewLine
                    End If
                    If (windowStyles2 And &H800000) <> 0 Then
                        op = op + "  WS_BORDER" + vbNewLine
                    End If
                    If (windowStyles2 And &H400000) <> 0 Then
                        op = op + "  WS_DLGFRAME" + vbNewLine
                    End If
                    If (windowStyles2 And &H10000) <> 0 Then
                        op = op + "  WS_ACTIVECAPTION" + vbNewLine
                    End If
                    If (windowStyles2 And &H8) <> 0 Then
                        op = op + "  WS_ALWAYSONTOP" + vbNewLine
                    End If
                    If (windowStyles2 And &H8) <> 0 Then
                        op = op + "  WS_EX_TOPMOST" + vbNewLine
                    End If
                    If (windowStyles2 And &H20000) <> 0 Then
                        op = op + "  WS_GROUP" + vbNewLine
                    End If
                    If (windowStyles2 And &H4) <> 0 Then
                        op = op + "  DS_3DLOOK" + vbNewLine
                    End If
                    If (windowStyles And &H1) <> 0 Then
                        op = op + "  DS_ABSALIGN" + vbNewLine
                    End If
                    If (windowStyles And &H800) <> 0 Then
                        op = op + "  DS_CENTER" + vbNewLine
                    End If
                    If (windowStyles And &H1000) <> 0 Then
                        op = op + "  DS_CENTERMOUSE" + vbNewLine
                    End If
                    If (windowStyles And &H2000) <> 0 Then
                        op = op + "  DS_CONTEXTHELP" + vbNewLine
                    End If
                    If (windowStyles And &H400) <> 0 Then
                        op = op + "  DS_CONTROL" + vbNewLine
                    End If
                    If (windowStyles And &H8) <> 0 Then
                        op = op + "  DS_FIXEDSYS" + vbNewLine
                    End If
                    If (windowStyles And &H80) <> 0 Then
                        op = op + "  DS_MODALFRAME" + vbNewLine
                    End If
                    If (windowStyles And &H20) <> 0 Then
                        op = op + "  DS_LOCALEDIT" + vbNewLine
                    End If
                    If (windowStyles And &H10) <> 0 Then
                        op = op + "  DS_NOFAILCREATE" + vbNewLine
                    End If
                    If (windowStyles And &H100) <> 0 Then
                        op = op + "  DS_NOIDLEMSG" + vbNewLine
                    End If
                    If (windowStyles And &H40) <> 0 Then
                        op = op + "  DS_SETFONT" + vbNewLine
                    End If
                    If (windowStyles And &H200) <> 0 Then
                        op = op + "  DS_SETFOREGROUND" + vbNewLine
                    End If
                    If (windowStyles And &H1000) <> 0 Then
                        op = op + "  DS_SHELLFONT" + vbNewLine
                    End If
                    If (windowStyles And &H2) <> 0 Then
                        op = op + "  DS_SYSMODAL" + vbNewLine
                    End If
                    Dim wClass As Byte = br.ReadByte
                    op = op + "  Window Class     : " + wClass.ToString + " ("
                    If wClass = 128 Then
                        op = op + "Button)" + vbNewLine
                    ElseIf wClass = 129 Then
                        op = op + "Edit)" + vbNewLine
                    ElseIf wClass = 130 Then
                        op = op + "Static)" + vbNewLine
                    ElseIf wClass = 131 Then
                        op = op + "Listbox)" + vbNewLine
                    ElseIf wClass = 132 Then
                        op = op + "Scrollbar)" + vbNewLine
                    ElseIf wClass = 133 Then
                        op = op + "Combobox)" + vbNewLine
                    Else
                        Stop
                    End If
                    Dim cntText As String = ""
                    rdByte = 0
                    Do
                        rdByte = br.ReadByte
                        If rdByte = 0 Then
                            Exit Do
                        End If
                        cntText = cntText + Chr(rdByte)
                    Loop
                    op = op + "  Control Text     : " + cntText + vbNewLine
                    Dim eData As Byte = br.ReadByte
                    If eData < 0 Then
                        Stop
                    End If
                Next
            End Using
        End Using

            Console.WriteLine(op)

        ''Catch ex As Exception
        ''Console.WriteLine("Error: " & ex.Message)
        ''End Try

    End Sub
End Module
